   This file documents GREP, a pattern matching engine.

   Published by the Free Software Foundation, 59 Temple Place - Suite
330 Boston, MA 02111-1307, USA

   Copyright (C) 1998 Free Software Foundation, Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that
the entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Foundation.

   This document was produced for version 2.3 of GNU GREP.

Introduction
************

   GREP searches the input files for lines containing a match to a given
pattern list.  When it finds a match in a line, it copies the line to
standard output (by default), or does whatever other sort of output you
have requested with options.  GREP expects to do the matching on text.
Since newline is also a separator for the list of patterns, there is no
way to match newline characters in a text.

Invoking GREP
*************

   GREP comes with a rich set of options from POSIX.2 and GNU
extensions.

`-c'
`--count'
     Suppress normal output; instead print a count of matching lines
     for each input file.  With the `-v', `--revert-match' option,
     count non-matching lines.

`-e PATTERN'
`--regexp=PATTERN'
     Use PATTERN as the pattern; useful to protect  patterns beginning
     with a `-'.

`-f FILE'
`--file=FILE'
     Obtain patterns from FILE, one  per  line.   The  empty file
     contains zero patterns, and therefore matches nothing.

`-i'
`--ignore-case'
     Ignore case distinctions in both the  pattern  and  the input
     files.

`-l'
`--files-with-matches'
     Suppress normal output; instead print the name of  each input file
     from which output would normally have been printed.  The scanning
     of every file will stop on the first match.

`-n'
`--line-number'
     Prefix each line of output with the line number  within its input
     file.

`-q'
`--quiet'
`--silent'
     Quiet; suppress normal output.  The scanning of every file will
     stop on the first match.  Also see the `-s' or `--no-messages'
     option.

`-s'
`--no-messages'
     Suppress error messages about nonexistent or unreadable files.
     Portability  note:  unlike  GNU GREP, BSD GREP does not comply
     with POSIX.2, because BSD GREP lacks a `-q'  option and its `-s'
     option behaves like GNU GREP's `-q' option.  Shell scripts
     intended to be portable to BSD GREP should avoid both `-q' and
     `-s' and should redirect output to `/dev/null' instead.

`-v'
`--revert-match'
     Invert the sense of matching,  to  select  non-matching lines.

`-x'
`--line-regexp'
     Select only those matches that exactly match the  whole line.

GNU Extensions
==============

`-A NUM'
`--after-context=NUM'
     Print NUM lines of trailing context after matching lines.

`-B NUM'
`--before-context=NUM'
     Print NUM lines of leading context before matching lines.

`-C'
`--context[=NUM]'
     Print NUM lines (default 2) of output context.

`-NUM'
     Same as `--context=NUM' lines  of  leading  and  trailing context.
     However, grep will never print any given line more than once.

`-V'
`--version'
     Print the version number of GREP to the standard output stream.
     This  version  number  should  be  included  in all bug reports.

`--help'
     Print a usage message briefly summarizing these command-line
     options and the bug-reporting address, then exit.

`-b'
`--byte-offset'
     Print the byte offset within the input file before each line of
     output.  When GREP runs on MS-DOS or MS-Windows, the printed byte
     offsets depend on whether the `-u' (`--unix-byte-offsets') option
     is used; see below.

`-d ACTION'
`--directories=ACTION'
     If an input file is a directory, use ACTION to  process it.  By
     default, ACTION is `read', which means that directories are read
     just  as  if  they  were  ordinary files (some operating systems
     and filesystems disallow this, and will cause GREP to print error
     messages for every directory).  If ACTION is `skip', directories
     are silently skipped.  If ACTION is `recurse', GREP reads all
     files under each directory, recursively; this is equivalent to the
     `-r' option.

`-h'
`--no-filename'
     Suppress the prefixing of filenames on output when multiple files
     are searched.

`-L'
`--files-without-match'
     Suppress normal output; instead print the name of  each input file
     from  which  no output would normally have been printed.  The
     scanning of every file will  stop  on  the  first match.

`-a'
`--text'
     Do not suppress output lines that contain binary  data.  Normally,
     if  the  first  few bytes of a file indicate that the file
     contains binary data, grep outputs only a message saying that the
     file matches the pattern.  This option causes grep to act as if
     the  file  is  a  text file, even if it would otherwise be treated
     as binary.  _Warning:_  the  result  might  be  binary garbage
     printed  to  the  terminal,  which  can  have  nasty side-effects
     if the terminal driver interprets some of it as commands.

`-w'
`--word-regexp'
     Select only those lines containing  matches  that  form whole
     words.   The test is that the matching substring must either be at
     the beginning of the  line,  or  preceded by a non-word
     constituent character.  Similarly, it must be either at the end of
     the line or followed by a  non-word  constituent  character.
     Word-constituent characters are letters, digits, and the
     underscore.

`-r'
`--recursive'
     For each directory mentioned in the command line, read and process
     all files in that directory, recursively.  This is the same as the
     `-d recurse' option.

`-y'
     Obsolete synonym for `-i'.

`-U'
`--binary'
     Treat the file(s) as binary.  By default, under  MS-DOS and
     MS-Windows, GREP guesses the file type by looking at the contents
     of the first 32KB read from  the  file.  If GREP decides the file
     is a text file, it strips the CR characters from the original file
     contents (to  make regular  expressions  with  `^' and `$' work
     correctly).  Specifying `-U' overrules this guesswork, causing all
     files  to  be read and passed to the matching mechanism verbatim;
     if the file is a text file with  CR/LF  pairs at  the  end of each
     line, this will cause some regular expressions to fail.  This
     option is only supported  on MS-DOS and MS-Windows.

`-u'
`--unix-byte-offsets'
     Report Unix-style byte  offsets.   This  switch  causes GREP to
     report byte offsets as if the file were Unix style text file, i.e.
     the byte offsets ignore the CR characters which were stripped
     off.  This  will produce results identical to running GREP on a
     Unix machine.  This option has no  effect  unless  `-b' option is
     also used; it is only supported on MS-DOS and MS-Windows.

   Several additional options control which variant of the GREP
matching engine is used.  See Grep Programs.

   GREP uses the environment variable LANG to provide
internationalization support, if compiled with this feature.

Diagnostics
***********

   Normally, exit status is 0 if matches were found, and 1 if no matches
were found (the `-v' option inverts the sense of the exit status).
Exit status is 2  if  there  were  syntax errors  in  the  pattern,
inaccessible input files, or other system errors.

GREP programs
*************

   GREP searches the named input files (or standard input if no files
are named, or the file name `-' is given) for lines containing a match
to the given pattern.  By default, GREP prints the matching lines.
There are three major variants of GREP, controlled by the following
options.

`-G'
`--basic-regexp'
     Interpret pattern as a basic  regular  expression.  This is the
     default.

`-E'

`--extended-regexp'
     Interpret pattern as  an  extended  regular  expression.

`-F'
`--fixed-strings'
     Interpret pattern as a list of fixed strings, separated by
     newlines, any of which is to be matched.

   In addition, two variant programs EGREP and FGREP are available.
EGREP is similar (but not identical) to `grep -E', and is compatible
with the historical Unix EGREP.  FGREP is  the same as `grep -F'.

Regular Expressions
*******************

   A "regular expression" is a pattern that describes  a  set  of
strings.  Regular expressions are constructed analogously to arithmetic
expressions, by using various operators  to  combine smaller
expressions.  GREP understands two different versions of  regular
expression syntax:   "basic"  and  "extended".  In GNU GREP, there is no
difference  in  available  functionality  using either  syntax.  In
other  implementations,  basic regular expressions are less powerful.
The  following  description applies  to  extended  regular  expressions;
differences for basic regular expressions are summarized afterwards.

   The fundamental building blocks are the regular  expressions that
match a single character.  Most characters, including all letters and
digits, are regular expressions  that  match themselves.  Any
metacharacter with special meaning may be quoted by preceding it with a
backslash.  A list of characters enclosed by `[' and `]' matches any
single character in that list; if the first character of the list is the
caret `^', then it matches any character *not* in the list.  For
example, the regular expression `[0123456789]' matches any single digit.
A range of ASCII characters  may be  specified  by  giving  the  first
and  last characters, separated by a hyphen.  Finally, certain  named
classes  of characters  are  predefined.   Their names are self
explanatory, and  they  are :

`[:alnum:]'
     Any of [:digit:] or [:alpha:]

`[:alpha:]'
     Any local-specific or one of the ASCII letters:
     `a b c d e f g h i j k l m n o p q r s t u v w x y z',
     `A B C D E F G H I J K L M N O P Q R S T U V W X Y Z'.

`[:cntrl:]'
     Any of `BEL', `BS', `CR', `FF', `HT', `NL', or `VT'.

`[:digit:]'
     Any one of `0 1 2 3 4 5 6 7 8 9'.

`[:graph:]'
     Anything that is not a `[:alphanum:]' or `[:punct:]'.

`[:lower:]'
     Any one of `a b c d e f g h i j k l m n o p q r s t u v w x y z'.

`[:print:]'
     Any character from the `[:space:]' class, and any character that is
     *not* in the `[:isgraph:]' class.

`[:punct:]'
     Any one of `! " #% & ' ( ) ; < = > ? [ \ ] * + , - . / : ^ _ { |
     }'.

`[:space:]'
     Any one of `CR FF HT NL VT SPACE'.

`[:upper:]'
     Any one of `A B C D E F G H I J K L M N O P Q R S T U V W X Y Z'.

`[:xdigit:]'
     Any one of `a b c d e f A B C D E F 0 1 2 3 4 5 6 7 8 9'.

   For example, `[[:alnum:]]' means `[0-9A-Za-z]', except the latter
form is dependent upon the ASCII character  encoding,  whereas  the
former  is portable.  (Note that the brackets in these class names are
part of the symbolic names, and must  be  included in  addition  to the
brackets delimiting the bracket list).  Most metacharacters lose their
special meaning inside lists.  To include a literal `]', place it first
in the list.  Similarly, to include a literal `^', place it anywhere
but  first.  Finally, to include a literal `-', place it last.

   The period `.' matches any single character.  The symbol `\w' is a
synonym for `[[:alnum:]]' and `\W' is a synonym for `[^[:alnum]]'.

   The caret `^' and the dollar sign `$' are metacharacters that
respectively match the empty string at the beginning and end of a line.
The symbols `\<' and  `\>' respectively match the empty string at the
beginning and end of a word.  The symbol `\b' matches the empty string
at the edge of a  word,  and  `\B' matches  the empty string provided
it's not at the edge of a word.

   A regular expression may  be  followed  by  one  of  several
repetition operators:

`?'
     The preceding item is optional and will be matched at most once.

`*'
     The preceding item will be matched zero or more times.

`+'
     The preceding item will be matched one or more times.

`{N}'
     The preceding item is matched exactly N times.

`{N,}'
     The preceding item is matched n or more times.

`{,M}'
     The preceding item is optional and is matched at most M times.

`{N,M}'
     The preceding item is matched at least N times, but not more than
     M times.

   Two regular expressions may be concatenated;  the  resulting regular
expression matches any string formed by concatenating two substrings
that respectively match the  concatenated subexpressions.

   Two regular expressions may be joined by the infix  operator `|'; the
resulting  regular  expression  matches  any string matching either
subexpression.

   Repetition takes precedence  over  concatenation,  which  in turn
takes precedence over alternation.  A whole subexpression may be
enclosed in parentheses to override  these  precedence rules.

   The backreference `\N', where N is a single digit, matches the
substring previously matched by the Nth parenthesized subexpression of
the regular expression.

   In basic regular expressions the metacharacters `?', `+', `{', `|',
`(', and `)' lose their special meaning; instead use the backslashed
versions `\?', `\+', `\{', `\|', `\(', and `\)'.

   In EGREP the metacharacter  `{'  loses  its  special  meaning;
instead use `\{'.  This not true for `grep -E'.

Reporting bugs
**************

   Email bug reports to <bug-gnu-utils@gnu.org>.  Be sure to include
the word "grep" somewhere in the "Subject:" field.

   Large repetition counts in the  `{m,n}'  construct  may  cause GREP
to  use  lots  of  memory.  In addition, certain other obscure regular
expressions  require  exponential  time  and space, and may cause grep
to run out of memory.  Backreferences are very slow, and  may  require
exponential time.

Concept Index
*************

   This is a general index of all issues discussed in this manual, with
the exception of the GREP commands and command-line options.

Index
*****

   This is an alphabetical list of all GREP commands and command-line
options.